
# tcl script for AntNet algorithm on an arbitrary topology of 12 nodes

#number of nodes
set sz 2

#Create event Schedular
set ns [new Simulator]

#Open the Trace file
set tf [open simple.out w]
$ns trace-all $tf

# nam trace initialization
#set namtrace [open sooa-out.nam w]     ; # for wireless traces
#$ns_ namtrace-all-wireless $namtrace $val(x) $val(y)
set nf [open simple.nam w]
$ns namtrace-all $nf

#Create 12 nodes
set n0 [$ns node]
set n1 [$ns node]
#Create links between the nodes
$ns duplex-link $n0 $n1 512Mb 155ms DropTail

#Create Antnet agents
set nn0 [new Agent/Antnet $n0]
set nn1 [new Agent/Antnet $n1]

#Attach each node with Antnet agent
$ns attach-agent $n0 $nn0
$ns attach-agent $n1 $nn1

#Create connection between the nodes
$ns connect $nn0 $nn1
#Add neighbors
$ns at now "$nn0 add-neighbor $n0 $n1"
# Set parameters and start time
$nn0 set num_nodes_ 10
$nn0 set timer_ant_ 0.03
$nn0 set r_factor_ 0.001
$ns at 1.0  "$nn0 start"
$nn1 set num_nodes_ 10
$nn1 set timer_ant_ 0.03
$nn1 set r_factor_ 0.001
$ns at 1.0  "$nn1 start"
#Set stop time for AntNet algorithm
$ns at 10.8 "$nn0 stop"
$ns at 10.8 "$nn1 stop"

#Print routing tables generated by AntNet
$ns at 10.9 "$nn0 print_rtable"
$ns at 10.9 "$nn1 print_rtable"
proc Finish {} {
	global ns tf nf
	$ns flush-trace
	close $nf
	#Close the Trace file
        close $tf
	exit 0
}
$ns  at 14.0 "Finish"
# Start the simulator
$ns  run
